//raspisdl3
//09/11/2013


#include <wiringPi.h>


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>


#include "main.h"

/*
Uint32 TimeLeft(void)
{
    static Uint32 next_time = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( next_time <= now ) {
        next_time = now+TICK_INTERVAL;
        return(0);
    }
    return(next_time-now);
}
*/

int load_files()
{
    background = load_image( "modelo2.jpg" );
    if( background == NULL )  return 0;
    
    background2 = load_image( "modelo3.jpg" );
    if( background2 == NULL )  return 0;
    
	dots = load_image( "modelo1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
		{
		 printf("Error cargando Font\n");
         return 0;
		}
	// Cargamos sonido
	if(SONIDO)sonido = Mix_LoadWAV("modelo.wav");
 	if(SONIDO)if ( sonido == NULL )
		{
		 printf("No pude cargar sonido: %s\n", Mix_GetError());
//     	 return 0;
 		}
  return 1;
}

void RepintarPantalla()
{
    SDL_WM_SetCaption( "Control Raspberry PI", NULL );
	apply_surface( 0, 0, background, screen );
	
	PaintBotones();	
	//PaintLuces();
	//PaintEntradas ();
	PaintTextos();
	SDL_Flip( screen );
}



void fOFF()
{
 int z;
	if(DEBUG)printf("ON all\n");
	for(z=0;z<17;z++)
		{
		 digitalWrite (z, LOW) ;
		 nzona[z].estado=0;
		 PaintZona(z);
		}
}

void fON()
{
 int z;
	if(DEBUG)printf("OFF all\n");
	for(z=0;z<17;z++)
		{
		 digitalWrite (z, HIGH) ;
		 nzona[z].estado=1;
		 PaintZona1(z);
		}		
}	
 

void Onzona(zzona)
{
	switch(zzona)
		{
		  case 0:
			digitalWrite (8, HIGH) ;
			break;
		  case 1:
			digitalWrite (9, HIGH) ;
			break;
		  case 2:
			digitalWrite (7, HIGH) ;
			break;
		  case 3:
			digitalWrite (0, HIGH) ;
			break;
		  case 4:
			digitalWrite (2, HIGH) ;
			break;
		  case 5:
			digitalWrite (12, HIGH) ;
			break;
		  case 6:
			digitalWrite (13, HIGH) ;
			break;
		  case 7:
			digitalWrite (14, HIGH) ;
			break;
		  case 8:
			digitalWrite (15, HIGH) ;
			break;
		  case 9:
			digitalWrite (16, HIGH) ;
			break;
		  case 10:
			digitalWrite (1, HIGH) ;
			break;
		  case 11:
			digitalWrite (4, HIGH) ;
			break;
		  case 12:
			digitalWrite (5, HIGH) ;
			break;
		  case 13:
			digitalWrite (6, HIGH) ;
			break;
		  case 14:
			digitalWrite (10, HIGH) ;
			break;		  
		  case 15:
			digitalWrite (11, HIGH) ;
			break;
		  case 16:
			digitalWrite (3, HIGH) ;
			break;
		  
		}
}	

void Offzona(zzona)
{
	switch(zzona)
		{
		  case 0:
			digitalWrite (8, LOW) ;
			break;
		  case 1:
			digitalWrite (9, LOW) ;
			break;
		  case 2:
			digitalWrite (7, LOW) ;
			break;
		  case 3:
			digitalWrite (0, LOW) ;
			break;
		  case 4:
			digitalWrite (2, LOW) ;
			break;
		  case 5:
			digitalWrite (12, LOW) ;
			break;
		  case 6:
			digitalWrite (13, LOW) ;
			break;
		  case 7:
			digitalWrite (14, LOW) ;
			break;
		  case 8:
			digitalWrite (15, LOW) ;
			break;
		  case 9:
			digitalWrite (16, LOW) ;
			break;
		  case 10:
			digitalWrite (1, LOW) ;
			break;
		  case 11:
			digitalWrite (4, LOW) ;
			break;
		  case 12:
			digitalWrite (5, LOW) ;
			break;
		  case 13:
			digitalWrite (6, LOW) ;
			break;
		  case 14:
			digitalWrite (10, LOW) ;
			break;		  
		  case 15:
			digitalWrite (11, LOW) ;
			break;
		  case 16:
			digitalWrite (3, LOW) ;
			break;
		}
}





int main (int argc, char *argv[])
{
 int quit = 0;
 int mouse_x,mouse_y;
 Uint8 *teclas; 
 int zboton=0;
 int canal;
 int zzona;
	
int z;
	
//___________Todos lo GPIO como salidas_____

	wiringPiSetup () ;
	for(z=0;z<17;z++)	pinMode (z, OUTPUT) ;

//________________	
	
	
	Initextos();
	Inibotones();	
	IniLuces ();	
	Inientradas();
	Inizonas();

	
    if( init() == 0 ) return 1;	
    if( load_files() == 0 ) return 2;	
	
	RepintarPantalla();			
	if( SDL_Flip( screen ) == -1 ) return 3;
	if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);
    
	 while( quit == 0 )
    {	
	  SDL_Delay(200);
/*
	    if(!TimeLeft())
 	                {
	                if(DEBUG)printf("time\n");				
                    }
*/
	  while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] ) quit = 1;
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");
				if(event.key.keysym.sym == SDLK_f)
                    {  
          #if YesWindows
                     screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
                     SDL_WM_ToggleFullScreen(screen);
          #endif  
                     RepintarPantalla();
                    }
				if(event.key.keysym.sym == SDLK_m)
				 {
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				 }
			}
			if( event.type == SDL_MOUSEBUTTONDOWN )
			  {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				
				if(zboton!=-1)
					{     
					 if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);                         
                 	 switch (zboton)
                        {                         
                         case 0:
							goto salir;                        
                         break;    
						 case 1:
							fOFF();                      
                         break;  
                         case 2:
							fON();                      
                         break;
                        default:                         
                     	printf("%s\n",VARI);					
                        }                               
					 PaintBoton(zboton,1);
					}

					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
					if( SDL_Flip( screen ) == -1 ) return 3;
			}
			if( event.type == SDL_MOUSEBUTTONUP ) {
				if(zboton!=-1)
				  {
					PaintBotones();
//					PaintLuces();
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
				  }
										
				zzona=DetecZonas(mouse_x,mouse_y);	
				if(DEBUG)printf("ZonaUp = %d\n",zzona);	
				if(zzona!=-1)
					{
					 if(nzona[zzona].estado==0)
						{
						 nzona[zzona].estado=1;						
						 sprintf(VARI,"1%s",nzona[zzona].nombre);						
						 PaintZona1(zzona);	
						 Onzona(zzona);
						}
					   else
						{
						 nzona[zzona].estado=0;						
						 sprintf(VARI,"0%s",nzona[zzona].nombre);						
						 PaintZona(zzona);	
						 Offzona(zzona);
						}
					 printf("%s\n",VARI);
	 
					 if(DEBUG)printf("estado zona %d \n",nzona[zzona].estado);
					 if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);
					 //SDL_Flip( screen );
					}	
								
				if( SDL_Flip( screen ) == -1 ) return 3;
			}	
        }		
	}
		
salir: 
     //Close all SDL
    clean_up();
    printf("Juan Galaz\nxsetaseta@gmail.com\n");
    return 0;  
}

//____________________FIN____________

